Package net.sf.saxon.value

## Class Closure

- java.lang.Object
- - net.sf.saxon.value.Closure

- All Implemented Interfaces:
    `ContextOriginator`, `Sequence`
  Direct Known Subclasses:
    `MemoClosure`, `SingletonClosure`

      public class Closure
      extends java.lang.Object
      implements Sequence, ContextOriginator

  A Closure represents a value that has not yet been evaluated: the value is represented by an expression, together with saved values of all the context variables that the expression depends on.

  This Closure is designed for use when the value is only read once. If the value is read more than once, a new iterator over the underlying expression is obtained each time: this may (for example in the case of a filter expression) involve significant re-calculation.

  The expression may depend on local variables and on the context item; these values are held in the saved XPathContext object that is kept as part of the Closure, and they will always be read from that object. The expression may also depend on global variables; these are unchanging, so they can be read from the Bindery in the normal way. Expressions that depend on other contextual information, for example the values of position(), last(), current(), current-group(), should not be evaluated using this mechanism: they should always be evaluated eagerly. This means that the Closure does not need to keep a copy of these context variables.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected int` | `depth` |
    `protected Expression` | `expression` |
    `protected SequenceIterator` | `inputIterator` |
    `protected XPathContextMajor` | `savedXPathContext` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Closure()` | Constructor should not be called directly, instances should be made using the make() method.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Expression` | `getExpression()` |
    `XPathContextMajor` | `getSavedXPathContext()` |
    `Item` | `head()` | Get the first item in the sequence.
    `SequenceIterator` | `iterate()` | Evaluate the expression in a given context to return an iterator over a sequence
    `static Sequence` | `make​(Expression expression, XPathContext context, int ref)` | Construct a Closure by supplying the expression and the set of context variables.
    `Sequence` | `makeRepeatable()` | Ensure that the sequence is in a form where it can be evaluated more than once.
    `GroundedValue` | `reduce()` | Reduce a value to its simplest form.
    `void` | `saveContext​(Expression expression, XPathContext context)` |
    `void` | `setExpression​(Expression expression)` |
    `void` | `setSavedXPathContext​(XPathContextMajor savedXPathContext)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `materialize`

- - ### Field Detail

    - #### expression

          protected Expression expression

    - #### savedXPathContext

          protected XPathContextMajor savedXPathContext

    - #### depth

          protected int depth

    - #### inputIterator

          protected SequenceIterator inputIterator

  - ### Constructor Detail

    - #### Closure

          public Closure()

      Constructor should not be called directly, instances should be made using the make() method.

  - ### Method Detail

    - #### make

          public static Sequence make​(Expression expression,
                                      XPathContext context,
                                      int ref)
                               throws XPathException

      Construct a Closure by supplying the expression and the set of context variables.
      Parameters:
        `expression` - the expression to be lazily evaluated
        `context` - the dynamic context of the expression including for example the variables on which it depends
        `ref` - the number of references to the value being lazily evaluated; this affects the kind of Closure that is created
      Returns:
        the Closure, a virtual value that can later be materialized when its content is required
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### saveContext

          public void saveContext​(Expression expression,
                                  XPathContext context)
                           throws XPathException

      Throws:
        `XPathException`

    - #### head

          public Item head()
                    throws XPathException

      Get the first item in the sequence.
      Specified by:
        `head` in interface `Sequence`
      Returns:
        the first item in the sequence if there is one, or null if the sequence is empty
      Throws:
        `XPathException` - in the situation where the sequence is evaluated lazily, and evaluation of the first item causes a dynamic error.

    - #### getExpression

          public Expression getExpression()

    - #### getSavedXPathContext

          public XPathContextMajor getSavedXPathContext()

    - #### setExpression

          public void setExpression​(Expression expression)

    - #### setSavedXPathContext

          public void setSavedXPathContext​(XPathContextMajor savedXPathContext)

    - #### iterate

          public SequenceIterator iterate()
                                   throws XPathException

      Evaluate the expression in a given context to return an iterator over a sequence
      Specified by:
        `iterate` in interface `Sequence`
      Returns:
        an iterator (specifically, a Saxon `SequenceIterator`, which is not a `Iterator`) over all the items
      Throws:
        `XPathException` - in the situation where the sequence is evaluated lazily, and constructing an iterator over the items causes a dynamic error.

    - #### reduce

          public GroundedValue reduce()
                               throws XPathException

      Reduce a value to its simplest form. If the value is a closure or some other form of deferred value such as a FunctionCallPackage, then it is reduced to a SequenceExtent. If it is a SequenceExtent containing a single item, then it is reduced to that item. One consequence that is exploited by class FilterExpression is that if the value is a singleton numeric value, then the result will be an instance of NumericValue
      Returns:
        the simplified value
      Throws:
        `XPathException` - if an error occurs doing the lazy evaluation

    - #### makeRepeatable

          public Sequence makeRepeatable()
                                  throws XPathException

      Description copied from interface: `Sequence`
      Ensure that the sequence is in a form where it can be evaluated more than once. Some sequences (for example `LazySequence` and `Closure` can only be evaluated once, and this operation causes these to be grounded. However, making it repeatable is not the same as making it grounded; it does not flush out all errors. Indeed, lazy evaluation relies on this property, because an expression that has been lifted out of a loop must not be evaluated unless the loop is executed at least once, to prevent spurious errors.
      Specified by:
        `makeRepeatable` in interface `Sequence`
      Returns:
        An equivalent sequence that can be repeatedly evaluated
      Throws:
        `XPathException` - if evaluation fails